/* Copyright (c) 2012 Sven Herrmann and Andreas Spillner

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#include "polymake/client.h"
#include "polymake/Rational.h"
#include "polymake/Array.h"

namespace polymake { namespace common {



perl::ListReturn array_to_int(const Array<Rational>& m)
{
   const int k=m.size();
   Integer factor(1);
   Array<Integer> m_int(k);
   for (int i=0;i<k;++i)
       if (m[i]!=0) factor=lcm(factor,denominator(m[i]));
   for (int i=0;i<k;++i)
       m_int[i]=floor(factor*m[i]);
   perl::ListReturn res;
   res<<factor<<m_int;
   return res;
   
}

Function4perl(&array_to_int, "array_to_int");

} }

// Local Variables:
// mode:C++
// c-basic-offset:3
// indent-tabs-mode:nil
// End:
