/* Copyright (c) 2012 Sven Herrmann and Andreas Spillner

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#include "polymake/client.h"
#include "polymake/Graph.h"
#include "polymake/Vector.h"

namespace polymake { namespace graph {

template <typename Scalar>
EdgeMap<Undirected, Scalar >
edge_lengths(const Graph<>& G, const NodeMap<Undirected, Vector<Scalar> >& coords)
{
   EdgeMap<Undirected,Scalar> lengths(G);

   for (Entire< Edges< Graph<> > >::const_iterator e=entire(edges(G));  !e.at_end();  ++e)
      lengths[*e]=accumulate(attach_operation(coords[e.from_node()]-coords[e.to_node()], operations::abs_value()), operations::add());
   return lengths;
}


FunctionTemplate4perl("edge_lengths(props::Graph NodeMap)");

} }

// Local Variables:
// mode:C++
// c-basic-offset:3
// indent-tabs-mode:nil
// End:
