/* Copyright (c) 2012 Sven Herrmann and Andreas Spillner

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#include "polymake/client.h"
#include "polymake/Matrix.h"

namespace polymake { namespace metric {

perl::Object sk_circular_metric(const int s, const int k)
{
  const int d=2*s*k;
  Matrix<int> M(d,d);
  for (int i=0;i<d-1;++i) {
     for (int j=i+1;j<i+s&&j<d;++j)
        M(i,j)=M(j,i)=2*(j-i);
     for (int j=i+s;j<d-s+i&&j<d;++j)
        M(i,j)=M(j,i)=2*s;
     for (int j=d-s+i;j<d;++j)
        M(i,j)=M(j,i)=2*(d-(j-i));
  }
  perl::Object m("Metric");
  m.take("DISTANCE_MATRIX")<<M;
  return m;
}


UserFunction4perl("# Gives the sk-circular metric defined in the paper optimal realisations"
                  "# of a family of finite metric",
                 &sk_circular_metric,"sk_circular_metric"); 

} }
