/* Copyright (c) 2012 Sven Herrmann and Andreas Spillner
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version: http://www.gnu.org/licenses/gpl.txt.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
import java.io.*;
import java.util.*;

public class CreateMIP
{
    public static void main(String[] args)
    {
       String infile = args[0];
       String outfilegrid = args[1];
       String outfileMIP = args[2];

       TreeSet plist = IO.readPoints(infile);
       //IO.printPoints(plist);

       TreeSet genPairs = ConstraintFinder.findGeneratingSet(plist);
       //IO.printPairs(genPairs);
       
       LinkedList edges = ConstraintFinder.setUpGridGraph(plist,genPairs);
       LinkedList vertices = ConstraintFinder.getGridVertices(plist,edges);
       //IO.printEdges(edges);
       //IO.printVertices(vertices);

       IO.writeGridToFile(edges,outfilegrid);
       IO.writeMIPToFile(edges,vertices,genPairs,outfileMIP);
    }
}
