/* Copyright (c) 2012 Sven Herrmann and Andreas Spillner
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version: http://www.gnu.org/licenses/gpl.txt.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */
import java.util.*;

public class Edge
{
   //endpoints of edge
   //u...bot/left
   //v...top/right
   Point u;
   Point v;

   //set of point pairs in generating set
   //associated with the corresponding directed edges
   TreeSet uvpairs;
   TreeSet vupairs;

   //needed to set up the constraints matrix
   int offset;
   int idx;

   public Edge(Point u,Point v)
   {
      this.u = u;
      this.v = v;
      this.uvpairs = new TreeSet(new PairComparator());
      this.vupairs = new TreeSet(new PairComparator());
      this.offset = 0;
      this.idx = 0;
   }

   public String length()
   {
      if((u.y).equals(v.y)) {return ((v.x).subtract(u.x)).toString();}
      else {return ((v.y).subtract(u.y)).toString();}
   }
}
